Bug 1029260 - [GSS] (6.4) Cannot use a ear-subdeployments-isolated attribute setting with a jboss-deployment-structure.xml
[GSS] (6.4) Cannot use a ear-subdeployments-isolated attribute setting with a...
Status: VERIFIED
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: EE (Show other bugs)
6.1.1
Unspecified Unspecified
unspecified Severity unspecified
: DR1
: EAP 6.4.0
Assigned To: baranowb
Pavel Slavicek
Scott Mumford
:
Depends On:
Blocks: 1134806
  Show dependency treegraph
 
Reported: 2013-11-11 20:47 EST by Eiichi Nagai
Modified: 2015-01-22 03:37 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
If you configure a ear-subdeployments-isolated attribute with <filename>jboss-deployment-structure.xml</filename> and put under a <EAR>/META-INF directory, the isolation flag was overwritten by the sub-system configuration. In JBoss EAP 6.4, this issue is fixed. The order of processing has been updated.
Story Points: ---
Clone Of:
: 1134806 (view as bug list)
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker WFLY-2569 Major Resolved Components in Web and EJB container should always have access to RAR included in the same EAR 2015-11-19 22:36 EST
JBoss Issue Tracker WFLY-3263 Major Resolved ear-sub-deployments-isolated is ignored from jboss-deployment-structure.xml 2015-11-19 22:36 EST

  None (edit)
Description Eiichi Nagai 2013-11-11 20:47:25 EST
Created attachment 822734 [details]
simple reproducer

Description of problem:
Even if configure a ear-subdeployments-isolated attribute with jboss-deployment-structure.xml [1] and put under a <EAR>/META-INF directory, the isolation flag will be overwritten by the sub-system configuration [2].

[1] jboss-deployment-structure.xml
<jboss-deployment-structure>
<ear-subdeployments-isolated>true</ear-subdeployments-isolated>
</jboss-deployment-structure>

[2] org.jboss.as.ee.component.deployers.DefaultEarSubDeploymentsIsolationProcessor.java
53#    @Override
54#    public void deploy(DeploymentPhaseContext phaseContext) throws DeploymentUnitProcessingException {
55#        final DeploymentUnit deploymentUnit = phaseContext.getDeploymentUnit();
56#        // we only process .ear
57#        if (!DeploymentTypeMarker.isType(DeploymentType.EAR, deploymentUnit)) {
58#            return;
59#        }
60#        final ModuleSpecification moduleSpecification = deploymentUnit.getAttachment(Attachments.MODULE_SPECIFICATION);
61#        // set the default ear subdeployment isolation value
-> 62#        moduleSpecification.setSubDeploymentModulesIsolated(earSubDeploymentsIsolated);
63#    }


Version-Release number of selected component (if applicable):
6.1.1
6.2.0 Beta1 (AS 7.3.0.Final-redhat-8)

How reproducible:
Always

Steps to Reproduce:
1. Run EAP 6 server (using a standalone.sh)
2. Depoloy a SimpleEAR.ear (This application sets a ear-subdeployments-isolated=true with META-INF/jboss-deployment-structure.xml).

Actual results:
3. You can deploy it.

Expected results:
4. Stop EAP 6 server.
5. Modify a standalone.xml
- Add following.

        <subsystem xmlns="urn:jboss:domain:ee:1.1">
            <ear-subdeployments-isolated>true</ear-subdeployments-isolated>

6. Run EAP 6 server (using a standalone.sh)
7. You cannot deploy the SimpleEAR.ear for NoClassDefFoundError or ClassNotFoundException.

I think that the result of Step 3 must be the same as this.
Comment 4 Jan Martiska 2014-09-18 02:59:28 EDT
Verified in EAP 6.4.0.DR1.1.

Note You need to log in before you can comment on or make changes to this bug.